package fishProject;

/********************************************
 * Title:      	Eye
 * Description:	Class to represent the fish eye.
 * @author 		Bjrn Hkon Horpestad
 * @version 	1.0
********************************************/

public class Eye{
	
	private float[] eyeCoord;
	private float factor = 1.0f;
	private int un = 4;
	private int vn = 4;
	
	/**
	*	Constructor
	**/
	public Eye() {
		setEyeCoord();
	}
	
	/**
	*	Eye()
	*	@param fac - float that tells the size of the Eye
	**/
	public Eye(float fac) {
		if(fac > 0.0f)
			factor = fac;
		setEyeCoord();
	}
	
	/**
	*	setEyeCoord()
	*	Method that sets the coordinates that are used on the eye bezier surface
	**/
	public void setEyeCoord() {
		float tmpEyeCoord[] =  {
    					-0.15f * factor, -0.05f * factor, -0.1f * factor, 
    					-0.1f * factor, 0.0f * factor,-0.2f * factor,
      					0.1f * factor, 0.0f * factor,-0.2f * factor, 
      					0.16f * factor,0.02f * factor,-0.1f * factor
 						,
 						-0.2f * factor, -0.07f * factor, -0.1f * factor, 
 						-0.1f * factor,-0.2f * factor,-0.1f * factor,
   						0.1f * factor, -0.1f * factor, -0.1f * factor, 
   						0.2f * factor,0.03f * factor,-0.1f * factor
 						, 
 						-0.2f * factor, -0.07f * factor, 0.1f * factor, 
 						-0.1f * factor,-0.2f * factor,0.1f * factor, 
  						0.1f * factor,-0.1f * factor,0.1f * factor, 
  						0.2f * factor,0.03f * factor, 0.1f * factor
      					, 
 						-0.15f * factor,-0.05f * factor,0.1f * factor, 
 						-0.1f * factor,0.0f * factor, 0.2f * factor,
   						0.1f * factor, 0.0f * factor, 0.2f * factor, 
   						0.15f * factor,0.02f * factor,0.1f * factor,
   						};	
   		eyeCoord = tmpEyeCoord;
	}
	
	/***
	*	getEyeCoord()
	*	@return float[] with the eye coordinates
	**/
	public float[] getEyeCoord() { return eyeCoord;	}
	
	/**
	*	getUN()
	*	@return int un
	**/
	public int getUN() { return un; }
	/**
	*	getVN()
	*	return int vn
	**/
	public int getVN() { return vn; }
}