package fishProject;

/******************************************************
 * Title:      	Fish
 * Description:	Fish class that represents the fish.
 * @author 		Bjrn Hkon Horpestad
 * @version 	1.0
****************************************/

public class Fish {
	
	private Tail fishTail;
	private BackFin fishBackFin;
	private Eye fishEye;
	private LeftSideFin leftFin;
	private RightSideFin rightFin;
	private float[] fishBody;
	private int un =4;      
   	private int vn =9;  
	private float factor = 1.0f;  // Describes the size of the fish.
	private float maxSwing = 1.0f; // The maximum swing on a 1:1 scale fish
	private float minSwing = -1.0f;	// The minimum swing on a 1:1 scale fish
	private float xStart1, xStart2, xStart3, xStart4, xStart5;
	private float xCtrp1_1, xCtrp2_1, xCtrp1_2, xCtrp2_2, xCtrp1_3, xCtrp2_3, xCtrp1_4, xCtrp2_4, xCtrp1_5, xCtrp2_5;
	private float xEnd1, xEnd2, xEnd3, xEnd4, xEnd5;
	private float yStart1, yStart2, yStart3, yStart4, yStart5;
	private float yCtrp1_1, yCtrp2_1, yCtrp1_2, yCtrp2_2, yCtrp1_3, yCtrp2_3, yCtrp1_4, yCtrp2_4, yCtrp1_5, yCtrp2_5;
	private float yEnd1, yEnd2, yEnd3, yEnd4, yEnd5;
	private float zStart1, zStart2, zStart3, zStart4, zStart5;
	private float zCtrp1_1, zCtrp2_1, zCtrp1_2, zCtrp2_2, zCtrp1_3, zCtrp2_3, zCtrp1_4, zCtrp2_4, zCtrp1_5, zCtrp2_5;
	private float zCtrp1_6, zCtrp2_6, zCtrp1_7, zCtrp2_7, zCtrp1_8, zCtrp2_8;
	private float zEnd1, zEnd2, zEnd3, zEnd4, zEnd5, zEnd6, zEnd7, zEnd8;
	
	/**
	*	Constructor
	*
	**/
	public Fish() {
		setCoordinates();
		setFishBody();
		setMaxSwing(factor);
		setMinSwing(factor);	
		fishTail = new Tail();
		fishBackFin = new BackFin();
		fishEye = new Eye();
		leftFin = new LeftSideFin();
		rightFin = new RightSideFin();
	}
	
	/**
	*	Constructor
	*	@param fac- float that says how big the fish will be.
	**/
	public Fish(float fac) {
		if(fac > 0.0f) // so that the fish doesnt get negative.
			factor = fac;
		setCoordinates();
		setFishBody();
		fishTail = new Tail(factor);
		fishBackFin = new BackFin(factor);
		fishEye = new Eye(factor);
		leftFin = new LeftSideFin(factor);
		rightFin = new RightSideFin(factor);
		setMaxSwing(factor);
		setMinSwing(factor);	
	}
	 /**
	 *	setCoordinates()
	 *	Method that sets all the coordinates to the fish into variables.
	 **/
	public void setCoordinates() {
		if(factor == 0.0f)
			factor = 1.0f;
			
		xStart1 = -3.5f* factor; xCtrp1_1 = 0.0f *factor ; xCtrp2_1 = 1.5f* factor; xEnd1 = 3.5f* factor;
		xStart2 = -3.4f* factor; xCtrp1_2 = 0.0f * factor; xCtrp2_2 = 1.5f * factor; xEnd2 = 3.6f * factor;
 		xStart3 = -3.3f* factor; xCtrp1_3 = 0.0f * factor; xCtrp2_3 = 1.5f * factor; xEnd3 = 3.7f * factor;
		xStart4 = -3.4f* factor; xCtrp1_4 = 0.0f * factor; xCtrp2_4 = 1.5f * factor; xEnd4 = 3.6f * factor;
		xStart5 = -3.5f * factor; xCtrp1_5 = -0.2f * factor; xCtrp2_5 = 1.5f* factor; xEnd5 = 3.5f * factor;
			
		yStart1 = -0.3f * factor; yCtrp1_1 = -1.7f * factor; yCtrp2_1 = -1.7f * factor; yEnd1 = -0.3f * factor;
		yStart2 = -0.3f * factor; yCtrp1_2 = -1.5f * factor; yCtrp2_2 = -1.5f * factor; yEnd2 = -0.3f * factor;
		yStart3 = 0.0f * factor; yCtrp1_3 = 0.0f * factor; yCtrp2_3 = 0.0f * factor; yEnd3 = 0.0f * factor;
		yStart4 = 0.3f * factor; yCtrp1_4 = 1.5f * factor; yCtrp2_4 = 1.5f * factor; yEnd4 = 0.3f * factor;
		yStart5 = 0.3f * factor; yCtrp1_5 = 2.4f * factor; yCtrp2_5 = 2.4f * factor; yEnd5 = 0.3f * factor;	
			
		zStart1 = 0.0f*factor; zCtrp1_1 = 0.0f*factor; zCtrp2_1 = 0.0f*factor; zEnd1 = 0.0f*factor; 
		zStart2 = 0.0f*factor; zCtrp1_2 = 0.7f*factor; zCtrp2_2 = 0.7f*factor; zEnd2 = 0.0f*factor;
		zStart3 = 0.0f*factor; zCtrp1_3 = 1.0f*factor; zCtrp2_3 = 1.0f*factor; zEnd3 = 0.02f*factor;
		zStart4 = 0.0f*factor; zCtrp1_4 = 0.7f*factor; zCtrp2_4 = 0.7f*factor; zEnd4 = 0.0f*factor;
		zStart5 = 0.0f*factor; zCtrp1_5 = 0.0f*factor; zCtrp2_5 = 0.0f*factor; zEnd5 = 0.0f*factor;
		zCtrp1_6 = -0.7f*factor; zCtrp2_6 = -0.7f*factor; zEnd6 = 0.0f*factor;
		zCtrp1_7 = -1.0f*factor; zCtrp2_7 = -1.0f * factor; zEnd7 = -0.02f*factor;
		zCtrp1_8 = -0.7f*factor; zCtrp2_8 = -0.7f * factor; zEnd8 = 0.0f*factor;
	}
	
	/**
	*	setFishBody()
	*	Method that sets all the controllpoints to the fish
	**/
	public void setFishBody() {
		/*This is the control coordinates to the bezier surface that represents the fish body */
	  		float tmpFishBody[] = {
			  		xStart1, yStart1, zStart1,
  				   	xCtrp1_1, yCtrp1_1, zCtrp1_1, 
  					xCtrp2_1, yCtrp2_1, zCtrp2_1, 
  					xEnd1, yEnd1, zEnd1
  					,
  					xStart2, yStart2, zStart2,
  					xCtrp1_2, yCtrp1_2, zCtrp1_2,
  					xCtrp2_2, yCtrp2_2, zCtrp2_2,
  					xEnd2, yEnd2, zEnd2
  					,
  					xStart3, yStart3, zStart3,
  					xCtrp1_3, yCtrp1_3, zCtrp1_3,
  					xCtrp2_3, yCtrp2_3, zCtrp2_3,
  					xEnd3, yEnd3, zEnd3
  					,
  					xStart4, yStart4, zStart4,
  					xCtrp1_4, yCtrp1_4, zCtrp1_4,
  					xCtrp2_4, yCtrp2_4, zCtrp2_4,
  					xEnd4, yEnd4, zEnd4
  					,
  					xStart5, yStart5, zStart5,
  					xCtrp1_5, yCtrp1_5, zCtrp1_5,
  					xCtrp2_5, yCtrp2_5, zCtrp2_5,
  					xEnd5, yEnd5, zEnd5
  					,
  					xStart4, yStart4, zStart4,
  					xCtrp1_4, yCtrp1_4, zCtrp1_6,
  					xCtrp2_4, yCtrp2_4, zCtrp2_6,
  					xEnd4, yEnd4, zEnd6
  					,
  					xStart3, yStart3, zStart3,
  					xCtrp1_3, yCtrp1_3, zCtrp1_7,
  					xCtrp2_3, yCtrp2_3, zCtrp2_7,
  					xEnd3, yEnd3, zEnd7				
					,
  					xStart2, yStart2, zStart2,
  					xCtrp1_2, yCtrp1_2, zCtrp1_8,
  					xCtrp2_2, yCtrp2_2, zCtrp2_8,
  					xEnd2, yEnd2, zEnd8
  					,
			  		xStart1, yStart1, zStart1,
  				   	xCtrp1_1, yCtrp1_1, zCtrp1_1, 
  					xCtrp2_1, yCtrp2_1, zCtrp2_1, 
  					xEnd1, yEnd1, zEnd1				
				   };
				   
	 	fishBody = tmpFishBody;
	}
	
	/**
	*	setMaxSwing()
	* 	Method that multiplies a factor wiht the already existing value maxSwing so that the swing corresponds with she size of the fish.
	*	@param swing - float that says how much bigger, or smaller the swing should be.
	**/
	public void setMaxSwing(float swing) { maxSwing = maxSwing* swing; }
	/**
	*	getMaxSwing()
	*	@return float maxSwing
	**/
	public float getMaxSwing() { return maxSwing; }
	/**
	*	setMinSwing()
	*	Method that multiplies a factor with the already existing value minSwing, so that the swing corresponds with the size of the fish.
	**/
	public void setMinSwing(float swing) { minSwing = minSwing * swing; }
	/**
	*	getMinSwing()
	*	@return float minSwing
	**/
	public float getMinSwing() { return minSwing; }
	/**
	*	getFactor()
	*	@return float factor of the fish
	**/
	public float getFactor() { return factor; }
	
	/**
	*	getFishBody()
	*	@return float[] fishBody, the control coordinates to the fishBody.
	**/
	public float[] getFishBody() { return fishBody; }
	
	/**
	*	getUN()
	*	@return int un
	**/
	public int getUN() { return un; }
	/**
	*	getVN()
	*	@return int vn
	**/
	public int getVN() { return vn; }
	/**
	*	getFishTail()
	*	@return Tail object that is the fish's own tail
	**/
	public Tail getFishTail() { return fishTail; }
	/**
	*	getBackFin()
	*	@return BackFin object that is the fish's own backFin
	**/
	public BackFin getBackFin() { return fishBackFin; }
	/**
	*	getFishEye()
	*	@return Eye the fishEye
	**/
	public Eye getFishEye() { return fishEye; }
	/**
	*	getLeftFin()
	*	@return LeftSideFin object that is the fish's left fin
	**/
	public LeftSideFin getLeftFin() { return leftFin; }
	/**
	*	getRightFin()
	*	@return RightSideFin object that is the fish's right fin
	**/
	public RightSideFin getRightFin() { return rightFin; }
	
	/**
	*	moveFish()
	*	Method that moves the z- coordinates to the fish body
	*	@param newZ - float containing the new coordinates.
	**/	
	public void moveFish(float newZ) {
		zStart1 = newZ;
	  	zStart2 = newZ;
	  	zStart3 = newZ;
	  	zStart4 = newZ;
	  	zStart5 = newZ;
	  		
	  	setFishBody();	
	}
}