package fishProject;

/**************************************************
 * Title:      	Vector3D
 * Description:	Class to help organizing and controlling 3d vectors.
 * @author 		Bjrn Hkon Horpestad
 * @version 	1.0
****************************************************/

public class Vector3D {
	private float x = 0.0f; 
	private float y = 0.0f; 
	private float z = 0.0f;
 
 	/**
 	*	Vector3D
 	*	@param xf - float the vector x - coord
 	* 	@param yf - float the vector y - coord
 	*	@param zf - float the vector z - coord
 	**/
	public Vector3D(float xf,float yf,float zf) {
		setX(xf); 
		setY(yf); 
		setZ(zf);
 	}
 	
 	/**
 	*	Empty constructer
 	**/
	public Vector3D() { }

	/**
	*	cross()
	*	Method that cross this vector with anothre vector
	*	@param w - Vector3D
	**/
	public void  cross(Vector3D w) {
	//C=AxB=(a2b3-a3b2, a3b1-a1b3, a1b2-a2b1)	
		float newX,newY,newZ;
		newX = y * w.getZ() - z * w.getY();
		newY = z * w.getX() - x * w.getZ();
		newZ = x * w.getY() - y * w.getX();
		x = newX;
		y = newY;
		z = newZ;
	}

	/**
	*	cross()
	*	Method that cross this vector with x, y and z coordinates
	*	@param wx - float 
	*	@param wy - float
	*	@param wz - float
	**/
	public void cross(float wx,float wy,float wz) {
		//C=AxB=(a2b3-a3b2, a3b1-a1b3, a1b2-a2b1)
		float newX, newY, newZ;
		newX = y * wz - z * wy;
		newY = z * wx - x * wz;
		newZ = x * wy - y * wx;
		x = newX;
		y = newY;
		z = newZ;
	}

	/**
	*	normalize()
	*	Method that normalizes the vector
	**/
	public void normalize() {
		float l = (float)Math.sqrt(x * x + y * y + z * z);
		x = x/l;
		y = y/l;
		z = z/l;
	}
	
	/**
	* 	General
	*	set*()
	*	Methods that sets new values.
	*	@param new* - float , the new value.
	**/
	public void setX(float newX) { x = newX; }
	public void setY(float newY) { y = newY; }
	public void setZ(float newZ) { z = newZ; }
	
	/**
	*	General
	*	get*()
	* 	@return * -  float, either x, y or z 
	**/
	public float getX() { return x; }
	public float getY() { return y; }
	public float getZ() { return z; }
}